#!/bin/bash

echo "gcc [gen_all]"
gcc -x c++ -lstdc++ -O2 -Wall -o gen_all gen_all.cpp || exit 1
echo "gcc [split]"
gcc -x c++ -lstdc++ -O2 -Wall -o split2 split2.cpp || exit 1
echo "gcc [aplusb_b3]"
gcc -x c++ -lstdc++ -O2 -Wall -o aplusb_b3 ../aplusb_b3.cpp || exit 1
echo "gcc [check]"
gcc -x c++ -lstdc++ -O2 -Wall -o check ../check.cpp || exit 1
echo "gen_all [tests.gen]"
./gen_all > tests.gen || exit 1
echo "split"
./split2 tests.hand tests.gen

for i in `ls ???`
do
  echo "aplusb [$i]"
  cp "$i" "aplusb.in"
  ./aplusb_b3 || exit 1
  mv "aplusb.out" "$i.a"
done
rm "aplusb.in"
rm "tests.gen"

# hmm...
for i in `ls ???`
do
  echo "check [$i]"
  ./check "$i" "$i.a" "$i.a" || exit 1
done
