#include <algorithm>
#include <cstdio>
#include <cassert>
#include <string>
#include <iostream>
#include <cmath>
#include <set>

using namespace std;  

//       
#define forit(i,s) for(__typeof(s.begin()) i = s.begin(); i != s.end(); i++)

long long mabs( long long x ){return x < 0 ? -x : x;}

// ,     
struct num
{
  long long a, b; //a - , b - 

  //     
  void upd()
  {
    long long t = __gcd(a, b); 
    a /= t, b /= t; 
    if (b < 0) 
    a = -a, b = -b;
  }

  // 
  num( long long _a = 0, long long _b = 1)
  {
    a = _a, b = _b, upd();
  }
  
  // ,  
  const num inv() {return num(b, a);}
  
  //  
  const num abs() {return num(mabs(a), mabs(b));}

  //  
  int sg(){return a > 0 ? +1 : a < 0 ? -1 : 0;}
};

//   
num operator + (num a, num b)
{
  long long t = __gcd(a.b, b.b);
  return num(a.a * (b.b / t)+ (a.b / t) * b.a, a.b * (b.b / t));
}

//   
num operator - (num a, num b)
{
  long long t = __gcd(a.b, b.b);
  return num(a.a * (b.b / t) - (a.b / t) * b.a, a.b * (b.b / t));
}

long long mult ( long long a, long long b )
{
  long long res = a * b;
 // assert(res >= a && res >= b);
  return res;

}

//       
bool operator < (num a, num b)
{
  return (long double)a.a / a.b < (long double)b.a / b.b;
  /*
  long long t = __gcd(a.b, b.b);
//  cerr << a.a << "/" << a.b << " " << b.a << "/" << b.b << endl;
  long long x1 = mult(a.a, (b.b / t)),
            x2 = mult(b.a, a.b / t);
  //cerr << x1 << " " << x2 << endl;
  return x1 < x2;
  return (a - b).a < 0;*/
}

//    
bool operator == (num a, num b){return a.a == b.a && a.b == b.b;}

int n, a, b, r[5];

//  ,   ,    
set <num> v[1 << 5];

int main( void )
{
  //  
  freopen("circuit.in", "r", stdin);
  freopen("circuit.out", "w", stdout);

  //   
  scanf("%d%d%d", &n, &a, &b);
  int sum = 0;
  for (int i = 0; i < n; i++)
    scanf("%d", &r[i]);

  //  v    
  for (int i = 0; i < n; i++)  
    v[1 << i].insert(num(r[i]));

  //  
  for (int c = 1; c < (1 << n); c++)
    for (int a = (c - 1) & c; a > 0; a = (a - 1) & c)
    {
      int b = c ^ a;
      // a  b --   c

      //     v[a]  v[b]
      forit(x, v[a]) forit(y, v[b])
      {
        num p = *x, q = *y;

        //  
        v[c].insert(p + q);

        //  
        v[c].insert((p.inv() + q.inv()).inv());
      }
    }

  //     
  num res(101 * 5), need(a, b);
  for (int i = 1; i < (1 << n); i++)
    forit(x, v[i])                                                                          	
    {
      num curr = (*x - need).abs();

      if (curr < res)
        res = curr;
    }

  //  
  cout << res.a << "/" << res.b;

  return 0;
}
