import java.io.*;
import java.lang.*;
import java.util.*;
import java.math.*;

public class cnk_pk_stupid
{

	void solve() throws IOException{
        int n = nextInt(),k=nextInt(),m=nextInt();
        BigInteger[] f = new BigInteger[n+1];

        f[0] = BigInteger.ONE;
        for (int i = 1; i <= n; i++)
            f[i] = f[i-1].multiply(BigInteger.valueOf(i));

        BigInteger ans = BigInteger.ZERO;

        for (int i = 0; i <= k; i++){
            if ((i & 1) == 0)
                ans = ans.add(f[n].divide(f[n-i]).divide(f[i]));
            else
                ans = ans.subtract(f[n].divide(f[n-i]).divide(f[i]));
        }

        int res = ans.mod(BigInteger.valueOf(m)).intValue();

        res = (res+m)%m;

        out.println(res);
        return;
    }

	public static void main(String[] args) throws IOException{
		new cnk_pk_stupid().run();
	}

    BufferedReader in;
    StringTokenizer tokenizer;
    PrintWriter out;

	public void run() throws IOException
	{
		try {                               
			Reader reader = new FileReader("cnk.in");
			Writer writer = new FileWriter("cnk.out");
            in = new BufferedReader(reader);
            tokenizer = null;
            out = new PrintWriter(writer);
            solve();
            in.close();
            out.close();
		} catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        } 		
	}

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(in.readLine());
        }
        return tokenizer.nextToken();
    }

}                                    
