import java.io.*;
import java.util.*;
import java.math.*;

class cnk_vs
{
	int maxn = (int)1e6+10;
	int fact[] = new int[maxn];
	int mod;
	
	int mpow(int a, int b)
	{
		int res = 1;
		while(b>0)
		{
			if((b&1)==1) res = (int)( (res * (long) a) % mod );
			a = (int)( (a * (long) a) % mod );
			b >>= 1;
		}
		return res;
	}
	int degC(int n)
	{
		return n<mod ? 0 : n/mod + degC(n/mod);
	}
	int sign(int n)
	{
		return (n&1)==1 ? -1 : 1;
	}
	int f(int n)
	{
		return n==0 ? 1 : (int)( ( ( fact[n%mod] * sign(n/mod) * (long)f(n/mod) ) % mod + mod) % mod );
	}
	int C(int n, int k)
	{
		if(k > n) return 0;
		int d = degC(n) - degC(n-k) - degC(k);
		if(d>0) return 0;
		int p = (int)( ( f(n) * (long) mpow( (int)( (f(n-k) * (long)f(k))%mod ), mod - 2) ) %mod );
		return p;
	}
	public void run() throws Exception
	{
		Scanner in = new Scanner(new File("cnk.in"));
		PrintWriter out = new PrintWriter("cnk.out");
		int n, k;
		n = in.nextInt();
		k = in.nextInt();
		mod = in.nextInt();

		fact[0] = 1;
		for(int i = 1 ; i < mod ; i++) fact[i] = (int)( (fact[i-1] * (long)i) % mod ); 
		
		int ans =( ( (k%2==1) ? - C(n-1, k) : C(n-1, k) ) + mod ) % mod;
		
		out.println(ans);
		out.close();
	}
	public static void main(String args[]) throws Exception
	{
		new cnk_vs().run();
	}
}