import Data.List

main :: IO ()
main = do
  content <- readFile "cnk.in"
  let numbers = map read ( words content )
  let [n, k, m] = numbers
  writeFile "cnk.out" ( show ( solve n k m ) ++ "\n" )

c :: Int -> Int -> Int -> Int
c m 0 0 = 1
c m 0 k = 0
c m n 0 = 1
c m n k = mod ( ( c m (n - 1) k ) + ( c m (n - 1) (k - 1) ) ) m

solve :: Int -> Int -> Int -> Int
solve n k m = sum ( map ( \x -> ( c m n x ) * (if odd x then -1 else 1) ) [0 .. k] )
