#include "testlib.h"

using namespace std;

bool checkPrime(int n){
    for (int i = 2; i*i <= n; i++)
        if (n % i == 0)
            return false;
    return true;
}

int main(){
    registerValidation();
    
    int n = inf.readInt(1, 1000000000, "n");
    inf.readSpace();
    inf.readInt(1, n, "k");
    inf.readSpace();
    int m = inf.readInt(1, 1000003, "m");   
    if (!checkPrime(m))
        quitf(_fail,"m is not prime\n");
    inf.readEoln();
    inf.readEof();               
    return 0;
}
