//    k (  )
#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define sz(a) (int)(a).size()
#define pb push_back

typedef long long ll;

struct lection
{
  int a, t;
};

bool operator < ( lection x, lection y )
{
  return (ll)x.a * y.t > (ll)y.a * x.t;
}

#define maxn 100010

int N, T, u[4];
lection a[maxn];
ll res = 0;

void dfs( int i, int t, ll sa )
{
  if (i == N)
  {
    res = max(res, sa);
    return;
  }

  if (u[a[i].t])
    dfs(i + 1, t, sa);
  else if (t + a[i].t <= T)
    dfs(i + 1, t + a[i].t, sa + a[i].a);
  else
    for (int k = 1; k <= 3; k++)
      if (!u[k])
        forn(v, 3)
        {
          int rest = v, t1 = t;
          ll sa1 = sa;

          u[k] = 1;
          for (int p = i - 1; p >= 0; p--)
            if (rest && a[p].t == k)
              t1 -= a[p].t, sa1 -= a[p].a, rest--;
          dfs(i, t1, sa1);
          u[k] = 0;
        }
}

int main()
{
  freopen("lecture.in", "r", stdin);
  freopen("lecture.out", "w", stdout);

  scanf("%d%d", &N, &T);
  forn(i, N)
    scanf("%d%d", &a[i].t, &a[i].a);
  sort(a, a + N);

  memset(u, 0, sizeof(u));
  res = 0;
  dfs(0, 0, 0);
  printf("%I64d\n", res);
  return 0;
}
