import java.util.*;
import java.io.*;
public class soldiers_am
  {
  static final String filename = "soldiers";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_NM = 200;
  static final int DBG = 0;
  static int N,M;
  static int a[][];
  static final int DX[] = {1,1,0,-1,-1,-1,0,1};
  static final int DY[] = {0,-1,-1,-1,0,1,1,1};
  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(2),i,j,k;
  M = z[0];
  N = z[1];
  int[] DO = new int[8];for(k=0;k<8;++k) DO[k] = DX[k] + DY[k] * N;
  if (M < 1 || M > MAX_NM) throw new Error("M - out of range");
  if (N < 1 || N > MAX_NM) throw new Error("N - out of range");
  a = new int[M][N];
  for(j=0;j<M;++j)
    {
    char b[] = in.readLine().toCharArray();
    if (b.length != N) throw new Error("a[" + j + "].length <> N");
    for(i=0;i<N;++i)
      {
      a[j][i] = b[i] - '0';
      if (a[j][i] < 0 || a[j][i] > 7)
        throw new Error("a[" + j + "][" + i + "] - out of range");
      }
    }
  int total = M * N,lt=0;
  BitSet A = new BitSet(total);A.set(0,total);
  int[][][] y = new int[8][M][N],x = new int[8][M][N];
  for(k=0;k<8;++k) for(j=0;j<M;++j) for(i=0;i<N;++i)
    {
    x[k][j][i] = i;
    y[k][j][i] = j;
    }
  int max_t = 100 * M * N;
  for(int t=0;t<=lt+8 && t < max_t;++t)
    {
    if (0 != DBG)
      {
      out.println("t = " + t);
      for(j=0;j<M;++j)
        {
        for(i=0;i<N;++i)
          {
          if (A.get(j*N + i)) out.print(a[j][i]);
          else out.print('o');
          }
        out.println();
        }
      out.println();
      }

    BitSet B = (BitSet) A.clone();
    int cur = total;
    for(k=A.nextSetBit(0); k>=0; k=A.nextSetBit(k+1))
      {
      j = k / N;
      i = k - j * N;
      int aji = a[j][i];
      int dx = DX[aji], dy = DY[aji], delta_o = DO[aji];
      int xx = x[aji][j][i] + dx,yy = y[aji][j][i] + dy, o = xx + yy * N;
      while(xx >= 0 && xx < N && yy >= 0 && yy < M)
        {
        if (A.get(o))
          {
          if (B.get(o)) {B.clear(o);--cur;}
          break;
          }
        xx += dx;
        yy += dy;
        o += delta_o;
        }
      x[aji][j][i] = xx;
      y[aji][j][i] = yy;
      a[j][i] = (aji+1) & 7;
      }
    A = B;
    if(cur<total) lt=t;
    total = cur;
    }
  out.println(total);
  //out.println(lt);
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
