#include <cstdio>

int h, w;

#define maxn 210

char a[maxn][maxn], tmp[maxn][maxn];
int dx[] = {1, 1, 0, -1, -1, -1, 0, 1},
    dy[] = {0, -1, -1, -1, 0, 1, 1, 1};

bool ok( int y, int x )
{
  return 0 <= y && y < h && 0 <= x && x < w;
}

int main( void )
{
  freopen("soldiers.in", "r", stdin);
  freopen("soldiers.out", "w", stdout);

  scanf("%d%d", &h, &w);
  for (int i = 0; i < h; i++)
    scanf("%s", a[i]);

  int left = 8;
  while (left--)
  {
    for (int i = 0; i < h; i++)
      for (int j = 0; j < w; j++)
        if (a[i][j])
        {
          int k = a[i][j] - '0'; 
          int y = i + dy[k], x = j + dx[k];
          while (ok(y, x) && !a[y][x]) y += dy[k], x += dx[k];
          if (ok(y, x))
          {
            tmp[y][x] = 1;
 //           fprintf(stderr, "%d %d %d\n", y, x, (int)a[y][x]);
          }
        }
    for (int i = 0; i < h; i++)
      for (int j = 0; j < w; j++)
      {
        if (tmp[i][j])
          tmp[i][j] = a[i][j] = 0, left = 8;
        if (a[i][j])
          a[i][j] = (a[i][j] - '0' + 1) % 8 + '0';
      }

  }

  int res = 0;
  for (int i = 0; i < h; i++)
    for (int j = 0; j < w; j++)
      res += a[i][j] >= '0';
  printf("%d\n", res);

  return 0;
}
