@echo off
call include.cmd
if "%1"=="" (
 set SOL=%TASK%_ng
) else (
 set SOL=%~n1
)
if exist tests (
 pushd tests
 set RELPATH=..
) else (
 set RELPATH=.
)
echo Compiling solution...
if exist %RELPATH%\%SOL%.cpp (
 g++ -O2 -Wall -Wl,--stack=67108864 %RELPATH%\%SOL%.cpp -o %SOL%.exe
) else if exist %RELPATH%\%SOL%.c (
 gcc -x c -O2 -Wall -Wl,--stack=67108864 %RELPATH%\%SOL%.c -o %SOL%.exe
) else if exist %RELPATH%\%SOL%.pas (
 fpc -FE. %RELPATH%\%SOL%
)
echo Processing solution %SOL% on tests...
for %%t in (??) do (
 copy %%t %TASK%.in
 %SOL%
 %RELPATH%\check.exe %%t %TASK%.out %%t.a
)
erase %SOL%.o
erase %SOL%.exe
if %RELPATH%==.. (
 popd
)
echo Done!
