@echo off

set n=timetable
set sol=yp
set comp=cpp

call genall

echo Compiling solution and checker...
g++ -O3 -Wall -o %n%_%sol%.exe ..\%n%_%sol%.cpp
g++ -o ..\check.exe -Wall -O2 ..\check.cpp

echo Generating answers...
for /l %%i in (1,1,9) do (
  if EXIST 0%%i (
    echo test #0%%i...
    copy 0%%i %n%.in > nul
    call runsol %comp% %n%_%sol%
    copy %n%.out 0%%i.a > nul
  )
)
for /l %%i in (10,1,99) do (
  if EXIST %%i (
    echo test #%%i...
    copy %%i %n%.in > nul
    call runsol %comp% %n%_%sol%
    copy %n%.out %%i.a > nul
  )
)

rem call checksol %n% %sol% %comp%
rem call checksol %n% asm cpp
