#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <algorithm>

using namespace std;

int rseed;
void osrand( int a ) { rseed = a; }
int orand() { return (rseed = (rseed * 239017 + 301703) & 0xffffff) >> 8; }
int r( int a, int b ) { return a + orand() % (b - a + 1); }

int main( int argc, char **argv )
{
  assert(argc == 6);
  int n = atoi(argv[1]);
  int k = atoi(argv[2]);
  int ma = atoi(argv[3]);
  int mh = atoi(argv[4]);
  osrand(atoi(argv[5]));
  printf("%d %d\n", n, k);
  for (int i = 0; i < n; i++)
  {
    int h = r(1, mh);
    int x = r(0, ma - mh);
    printf("%d %d\n", x, x + h);
  }
  return 0;
}
