#include <algorithm>
#include <cstdio>
#include <vector>


using namespace std;

#define maxn 200000

int a[maxn], s[maxn], res[maxn];

int get()
{
  int x, y;
  scanf("%d%d", &x, &y);
  x = s[x] - y;
  return x;
}

int main( void )
{
  freopen("worms.in", "r", stdin);
  freopen("worms.out", "w", stdout);

  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 0; i < n; i++)
    scanf("%d", &a[i]);

  for (int i = 0; i < n; i++)
    s[i + 1] = s[i] + a[i];

  vector < pair <int, int> > v;
  v.push_back(make_pair(0, +1));
  v.push_back(make_pair(s[n] - 1, -1));

  for (int i = 0; i < m; i++)
  {
    int a = get(), b = get();
    if (a > b)
      swap(a, b);
    v.push_back(make_pair(a, +1));
    v.push_back(make_pair(b, -1));
  //  fprintf(stderr, "(%d..%d)\n", a, b);
  }
  sort(v.begin(), v.end());

  int i = 0, p = -1, curr = 0;
  while (i < (int)v.size())
  {
    res[curr] += v[i].first - p - 1;
    p = v[i].first;
    int j = i;
    int add = 0, sub = 0;
    while (j < (int)v.size() && v[j].first == v[i].first)
    {
      if (v[j].second > 0)
        add++;
      else
        sub++;
      j++;
    }
//    fprintf(stderr, "curr = %d, add = %d, sub = %d\n", curr, add, sub);
    res[curr + add]++;
    curr += add - sub;
    i = j;
  }

  for (int i = 1; i <= m + 1; i++)
    printf("%d\n", res[i]);

  return 0;
}