/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef pair<int, int> pii;

const int N = 1e5, M = 1e5;

int n, m, ans[M];
struct Event {
	int x, i, t;
	bool operator < ( const Event &e ) const { return pii(x, t) < pii(e.x, e.t); }
} e[N + 2 * M];

int main() {
	#define NAME "segpnt"
	assert(freopen(NAME ".in", "r", stdin));
	assert(freopen(NAME ".out", "w", stdout));

	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m;
	forn(i, n)
		cin >> e[i].x;
	forn(i, m) {
		cin >> e[n].x, e[n].i = i, e[n++].t = -1;
		cin >> e[n].x, e[n].i = i, e[n++].t = 1;
	}
	sort(e, e + n);

	int cnt = 0;
	forn(i, n) {
		cnt += !e[i].t;
		ans[e[i].i] += cnt * e[i].t;
	}
	forn(i, m)
		cout << ans[i] << " ";
	return 0;
}
