#include <cassert>
#include <cstdio>
#include <cstring>

#include <iostream>
#include <vector>

using namespace std;

int main () {
  int n, m;
  assert (scanf ("%d%d", &n, &m) == 2);
  vector <int> v[n], vf[n];
  bool large[n];
  for (int i = 0; i < m; i++) {
    int a, b;
    assert (scanf ("%d%d", &a, &b) == 2);
    a--, b--;
    v[a].push_back (b);
    v[b].push_back (a);
  }
  for (int i = 0; i < n; i++)
    large[i] = v[i].size () >= 320;
  for (int i = 0; i < n; i++)
    for (int j = 0; j < (int)v[i].size (); j++)
      if (large[v[i][j]])
        vf[i].push_back (v[i][j]);

  long long cf[n], ct[n];
  memset (cf, 0, sizeof (cf[0]) * n);
  memset (ct, 0, sizeof (ct[0]) * n);

  int q;
  assert (scanf ("%d", &q) == 1);
  for (int i = 0; i < q; i++) {
    int k, u, t;
    assert (scanf ("%d%d", &k, &u) == 2);
    u--;
    if (k == 0) {
      assert (scanf ("%d", &t) == 1);
      cf[u] += t;
      if (!large[u])
        for (int j = 0; j < (int)v[u].size (); j++)
          ct[v[u][j]] += t;
    } else if (k == 1) {
      long long res = ct[u];
      for (int j = 0; j < (int)vf[u].size (); j++)
        res += cf[vf[u][j]];
      cout << res << endl;
    }
  }

  return 0;
}

