# -*- coding: utf-8 -*-

# Пример того, как сделать глубокую рекурсию.
# Например полезно, когда пишите dfs на графе из 10^5 вершин

import sys, threading
sys.setrecursionlimit(10**7) # максимальная глубина рекурсии
threading.stack_size(2**25)  # каждый новый поток получит стек такого размера

def f(a, b): # В этой функции содержится основное решение, она будет вызвана в отдельном потоке
  print(a + b)

thread = threading.Thread(target=f, args=[2, 3])
thread.start()
thread.join()
