# -*- coding: utf8 -*-

import sys
from collections import namedtuple

# tuple -- неизменяемый (immutable) list
# easy tuples
# a = (1, 2)
# b = list(a)
# c = tuple(b)
# a[0], a[1]

# named tuples
Point = namedtuple("point", "x y") # Создали структуру
p = [Point(*map(int, s.split())) for s in sys.stdin.readlines()] # Создали массив структур

print(sorted(p)) # Отсортировали точки, как пары
print(p[0].x, p[0].y) # Вывели координаты первой точки
