#include <cstdio>
#include <cstring>
#include <cassert>

#define m 3000100

int c[m];
char a[m], b[m];
            
int main(void)
{
  freopen("aplusb.in", "r", stdin);
  freopen("aplusb.out", "w", stdout);

  gets(a), gets(b);
  int al = strlen(a), bl = strlen(b);
  assert(1 <= al && al <= 1000000);
  assert(1 <= bl && bl <= 1000000);

  memset(c, 0, sizeof(c));
  for (int i = 0; i < al; i++)
  {
    assert('0' <= a[i] && a[i] <= '3');
    c[al - i - 1] += a[i] - '0';
  }
  if (al > 1)
    assert('0' < a[0]);
  for (int i = 0; i < bl; i++)
  {
    assert('0' <= b[i] && b[i] <= '3');
    c[bl - i - 1] += b[i] - '0';
  }
  if (bl > 1)
    assert('0' < b[0]);

  for (int i = 0; i < m; i++)
  {
    while (c[i] < 0)
      c[i] += 4, c[i + 2]++;
    while (c[i] >= 4)
      c[i] -= 4, c[i + 2]--;
  }

  int p = m - 1;
  while (!c[p] && p)
    p--;
  while (p >= 0)
    putc(c[p--] + '0', stdout);
  puts("");

  return 0;
}
