#include <stdio.h>
#include <ctype.h>
#include <iostream>
#include <math.h>
#include <string.h>
#include <algorithm>
#include <stdlib.h>
#include <time.h>
#include <queue>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <utility>
#include <assert.h>

//#define M_PI 3.141592653589793238462643
#define eps 1e-8
#define inf ((int)1e9)
#define pb push_back
#define mp make_pair
#define taskname "cnk"

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif


using namespace std;

long long F[1100000], mod;

long long deg (long long v, int d)
{
  if (d==0)
    return 1ll;
  if (d&1)
    return (deg(v,d-1)*v)%mod;
  return deg((v*v)%mod,d/2);
}

long long calc (int v)
{
  if (v<mod)
    return F[v];
  return (((deg(mod-1,v/mod)*calc(v/mod))%mod)*F[v%mod])%mod;
}

int main()
{
  int n, m, k, i;
  freopen(taskname".in", "r", stdin);
  freopen(taskname".out", "w", stdout);
  assert(scanf("%d%d%d", &n, &k, &m)==3);
  assert(1<=k && k<=n && n<=inf && 1<=m && m<=1000003);
  n--;
  if (n<k)
  {
    puts("0");
    return 0;
  }
  int dd=0, tmp=n;
  while (tmp>0)
    tmp/=m, dd+=tmp;
  tmp=k;
  while (tmp>0)
    tmp/=m, dd-=tmp;
  tmp=n-k;
  while (tmp>0)
    tmp/=m, dd-=tmp;
  if (dd)
  {
    puts("0");
    return 0;
  }
  for (F[0]=1, i=1; i<m; i++)
    F[i]=(F[i-1]*1ll*i)%((long long)m);
  mod=m;
  long long res=calc(n);
  res*=deg((calc(k)*calc(n-k))%mod,m-2); 
  //cerr<<calc(n)<<" "<<calc(k)<<" "<<calc(n-k)<<endl;
  if (k&1)
    res%=mod, res=mod-res;
  printf(LLD, res%mod);
  return 0;
}