#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <ctime>

#define next next_asdf
#define prev prev_asdf
#define y1 y1_asdf
#define ws ws_asdf

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),(a).end()
#define forn(i, n) for(int (i)=0;(i)<(n);++(i))
#define ford(i, n) for(int (i)=1;(i)<=(n);++(i))
#define forit(it, v) for(typeof((v).begin()) (it)=(v).begin();(it)!=(v).end();++(it))

#ifdef home
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) {}
#endif

#ifdef WIN32
	#define I64 "%I64d"
#else
	#define I64 "%lld"
#endif

using namespace std;

typedef long long ll;
typedef double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

const ld eps=1e-10;
const int inf=(int)1e9;

/* --- main part --- */

#define TASK_NAME "cnk"
const int maxn = (int)1e6+10;
int fact[maxn], mod;
int mpow(int a, int b)
{
	int res = 1;
	while(b)
	{
		if(b&1) res = (res * (ll)a) % mod;
		a = (a * (ll)a) % mod;
		b >>= 1;
	}
	return res;
}
int degC(int n)
{
	return n < mod ? 0 : (n / mod + degC(n / mod));
}
inline int sign(int k) { return (k&1) ? -1 : 1; } 
int f(int n)
{
	return n == 0 ? 1 : ( ( fact[n % mod] * sign(n / mod) * (ll) f(n / mod)) % mod + mod ) % mod;
}
int C(int n, int k)
{
	if(k > n) return 0;
	int deg = degC(n) - degC(n-k) - degC(k);
	if(deg) return 0;
	return (f(n) * (ll)mpow( ( f(n-k) * (ll) f(k) ) % mod , mod - 2 )) % mod;
}
int main()
{
	assert(freopen(TASK_NAME".in", "r", stdin));
	assert(freopen(TASK_NAME".out", "w", stdout));
	int n, k;
	assert(scanf("%d%d%d", &n, &k, &mod) == 3);
	fact[0] = 1;
	for( int i = 1 ; i < mod ; i++ ) fact[i] = (fact[i-1] * (ll)i) % mod;  
	int ans =  ( ((k&1) ? -C(n-1, k) : C(n-1, k)) % mod + mod) % mod;
	printf("%d\n", ans);
	#ifdef home
		eprintf("%d ms\n", (int)(clock()*1000.0/CLOCKS_PER_SEC));
	#endif
	return 0;
}	



