#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <ctime>

#define next next_asdf
#define prev prev_asdf
#define y1 y1_asdf
#define ws ws_asdf

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),(a).end()
#define forn(i, n) for(int (i)=0;(i)<(n);++(i))
#define ford(i, n) for(int (i)=1;(i)<=(n);++(i))
#define forit(it, v) for(typeof((v).begin()) (it)=(v).begin();(it)!=(v).end();++(it))

#ifdef home
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) {}
#endif

#ifdef WIN32
	#define I64 "%I64d"
#else
	#define I64 "%lld"
#endif

using namespace std;

typedef long long ll;
typedef double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

const ld eps=1e-10;
const int inf=(int)1e9;

/* --- main part --- */

#define TASK_NAME "cnk"
int mod;
const int maxn = 1010;
int c[maxn][maxn];
void precalc()
{
	for(int i = 0 ; i < maxn ; i++)
	{
		c[i][0] = 1;
		for(int j = 1 ; j <= i ; j++) c[i][j] = (c[i-1][j-1] + c[i-1][j]) % mod;
	}
}
int C(int n, int k)
{
	if(n >= maxn)
	{
		printf("it's to hard to me!! :(\n");
		exit(0);
	}
	return c[n][k];
}
int main()
{
	assert(freopen(TASK_NAME".in", "r", stdin));
	assert(freopen(TASK_NAME".out", "w", stdout));
	int n, k;
	scanf("%d%d%d", &n, &k, &mod);
	precalc();
	int ans = 0;
	for(int i = 0 ; i <= k ; i++ ) ans = (ans + ((i&1) ? - C(n, i) : C(n, i)) + mod) % mod;
	printf("%d\n", ans); 
	#ifdef home
		eprintf("%d ms\n", (int)(clock()*1000.0/CLOCKS_PER_SEC));
	#endif
	return 0;
}	



