import java.util.*;
import java.io.*;
public class diamond_am
  {
  static final String filename = "diamond";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_NM = 500;
  static int N,M;
  static int a[][];
  static char b[][];
  static int[][] f(int start_row,int end_row,int delta_y)
  {
  int c[][] = new int[M][N];
  end_row += delta_y;
  for(int x=0;x<N;++x)
    {
    for(int y=start_row;y!=end_row;y+=delta_y)
      {
      char ch = b[y][x];
      int sz=0;
      for(int i=x,j=y;i>=0 && j!=end_row && a[j][i] >= 1+(sz<<1) && ch == b[j][i];--i,j+=delta_y,++sz);
      c[y][x] = sz-1;
      }
    }
  return c;
  }

  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(2),i,j,k;
  M = z[0];
  N = z[1];
  if (M < 1 || M > MAX_NM) throw new Error("M - out of range");
  if (N < 1 || N > MAX_NM) throw new Error("N - out of range");
  b = new char[M][];
  for(j=0;j<M;++j)
    {
    b[j] = in.readLine().toCharArray();
    if (b[j].length != N) throw new Error("b[" + j + "].length <> N");
    for(i=0;i<N;++i) if ('A' > b[j][i] || 'Z' < b[j][i])
      throw new Error("b[" + j + "][" + i + "] - not capital latin letter");
    }
  a = new int[M][N];
  for(j=0;j<M;++j)
    {
    a[j][N-1] = 1;
    for(i=N-2;i>=0;--i)
      a[j][i] = 1 + (b[j][i+1] == b[j][i] ? a[j][i+1] : 0);
    }
  int[][] down = f(0,M-1,1), up = f(M-1,0,-1);
  int xc=0,yc=0,r=0;
  for(j=0;j<M;++j)
    for(i=0;i<N;++i)
      {
      char ch = b[j][i];
      for(k=1;j-k >= 0 && j+k < M && i-k >= 0 && i+k < N;++k)
        {
        if (up[j+k][i] >= k && down[j-k][i] >= k && b[j+k][i] == ch && b[j-k][i] == ch && r < k)
          {
          r = k;yc = j;xc = i;
          }
        }
      }

  if ((1+r) > (yc+1) || (yc+1) > (M - r) ||
      (1+r) > (xc+1) || (xc+1) > (N - r)) throw new Error("output diamond doesn't fit in rectangle");

  char ch = b[yc][xc];
  for(j=0;j<M;++j)for(i=0;i<N;++i)
    if (Math.abs(j-yc)+Math.abs(i-xc) <= r && b[j][i] != ch)
      throw new Error("b[" + j + "][" + i + "] <> b[" + yc + "][" + xc + "]");

  ++xc;++yc;
  out.println(yc + " " + xc + " " + r);
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
