#include <algorithm>
#include <cstdio>

using namespace std;

int h, w;

#define maxn 550

char a[maxn][maxn];
int fu[maxn][maxn][4], fd[maxn][maxn][4], f[maxn][maxn][4], was[maxn][maxn][4],
    dx[4] = {1, 0, -1, 0}, dy[] = {0, 1, 0, -1};

bool ok( int y, int x )
{
  return 0 <= y && y < h && 0 <= x && x < w;
}

int get( int y, int x, int d )
{
  if (!ok(y, x))
    return 0;

  if (was[y][x][d])
    return f[y][x][d];

  was[y][x][d] = 1;

  fu[y][x][d] = fd[y][x][d] = f[y][x][d] = 1;

  int e = (d + 1) % 4;
  get(y + dy[d], x + dx[d], d);
  get(y + dy[e], x + dx[e], d);

  if (ok(y + dy[d], x + dx[d]) && a[y + dy[d]][x + dx[d]] == a[y][x])
    fu[y][x][d] += fu[y + dy[d]][x + dx[d]][d];

  if (ok(y + dy[e], x + dx[e]) && a[y + dy[e]][x + dx[e]] == a[y][x])
    fd[y][x][d] += fd[y + dy[e]][x + dx[e]][d];

  
  int ny = y + dy[d] + dy[e], nx = x + dx[d] + dx[e], add = 0;
  if (ok(ny, nx) && (a[ny][nx] == a[y][x]))
    add = get(ny, nx, d);
  f[y][x][d] = min(min(fd[y][x][d], fu[y][x][d]), add + 2);

  //fprintf(stderr, "%d %d %d: (%d %d %d)\n", y, x, d, f[y][x][d], fu[y][x][d], fd[y][x][d]);
  return f[y][x][d];
}

int main( void )
{
  freopen("diamond.in", "r", stdin);
  freopen("diamond.out", "w", stdout);

  scanf("%d%d", &h, &w);

  for (int i = 0; i < h; i++)
    scanf("%s", a[i]);

  int ri = 1, rj = 1, r = 1;
  for (int i = 0; i < h; i++)
    for (int j = 0; j < w; j++)
    {
      int curr = min(min(get(i, j, 0), get(i, j, 1)), min(get(i, j, 2), get(i, j, 3)));
//      fprintf(stderr, "%d %d : (%d %d %d %d)\n", i, j, get(i, j, 0), get(i, j, 1), get(i, j, 2), get(i, j, 3));
      //fprintf(stderr, "%d\n", curr);
      if (curr > r)
        ri = i + 1, rj = j + 1, r = curr;
    }
  printf("%d %d %d\n", ri, rj, r - 1);

  return 0;
}
