import java.util.*;
import java.io.*;
public class lecture_am
  {
  static final String filename = "lecture";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_N = (int) 1e5;
  static final int MAX_T = (int) 3e5;
  static final int MAX_AI = (int) 1e9;
  static final int TOLERANCE = 500;/* Complexity: O(N*log(N) + TOLERANCE ^ 2) */
  static int N,T;
  static int a[][];
  static char b[][];
  @SuppressWarnings("unchecked")
  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(2),i,j,k;
  N = z[0];T = z[1];
  if (N < 1 || N > MAX_N) throw new Error("N = " + N + " is out of range");
  if (T < 1 || T > MAX_T) throw new Error("T = " + T + " is out of range");
  Vector[] v = new Vector[4];
  for(i=1;i<=3;++i) v[i] = new Vector<Integer>();
  for(i=0;i<N;++i)
    {
    z = readIntegersSeparatedByOneSpace(2);
    int t = z[0],a = z[1];
    if (t < 1 || t > 3)
      throw new Error("t[" + i + "] = " + a + " is out of range");
    if (a < 0 || a > MAX_AI)
      throw new Error("a[" + i + "] = " + a + " is out of range");
    v[t].add(a);
    }
  int c[] = new int[4];
  long cum[][] = new long[4][];
  int a[][] = new int[4][];
  for(i=1;i<=3;++i)
    {
    Vector<Integer> w = v[i];
    Collections.sort(w);
    Collections.reverse(w);
    c[i] = w.size();
    cum[i] = new long[c[i]+1];
    a[i] = new int[c[i]];
    for(j=1;j<=c[i];++j)
      {
      a[i][j-1] = w.get(j-1);
      cum[i][j] = cum[i][j-1] + ((long) a[i][j-1]);
      }
    }
  assert(c[1] + c[2] + c[3] == N);

  int x[] = new int[4];
  int curT = 0;
  for(k=0;k<N;++k)
    {
    int tb = 4;
    long ab = -1;
    for(i=1;i<=3;++i) if (x[i] < c[i])
      {
      if (ab * i < ((long) a[i][x[i]]) * tb) {tb = i; ab = a[i][x[i]];}
      }
    if (curT + tb > T) break;
    curT += tb;
    ++x[tb];
    }
  //System.err.println(x[1] + " "  + x[2] + " " + x[3]);

  int lo_c3 = Math.max(0, x[3] - TOLERANCE);
  int hi_c3 = Math.min(c[3], x[3] + TOLERANCE);
  int lo_c2 = Math.max(0, x[2] - TOLERANCE);
  int hi_c2 = Math.min(c[2], x[2] + TOLERANCE);
  long ans = Long.MIN_VALUE;
  for(int c3=lo_c3;c3<=hi_c3;++c3)
    {
    int T3 = T - c3 * 3;if (T3 < 0) break;
    long f3 = cum[3][c3];
    for(int c2=lo_c2;c2<=hi_c2;++c2)
      {
      int T2 = T3 - c2 * 2;if (T2 < 0) break;
      int c1 = Math.min(T2,c[1]);
      long f = cum[1][c1] + cum[2][c2] + f3;
      if (ans < f)
        {
        //System.err.println(c1 + " " + c2 + " " + c3 + " " + f);
        ans = f;
        }
      }
    }
  out.println(ans);
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
