#include <cstdio>
#include <iostream>
#include <algorithm>
#include <functional>
#include <cassert>

using namespace std;

#define m 101000

int k[3], n, t, p1, p2, p3;
long long a[3][m], ans;

int len() { return 1 * p1 + 2 * p2 + 3 * p3; }
long long sum() { return a[0][p1] + a[1][p2] + a[2][p3]; }

void update()
{
  int d = 5, bp1 = -1, bp2 = -1, bsum = -1;
//  fprintf(stderr, "ans <- %lld len = %d p1=%d p2=%d p3=%d\n", sum(), len(), p1, p2, p3);
  for (int i = -d; i <= d; i++)
    for (int j = -d; j <= d; j++)
    {
      p1 += i, p2 += j;
      if (0 <= p1 && p1 < k[0] && 0 <= p2 && p2 < k[1] && len() <= t)
        if (bsum < sum())
          bsum = sum(), bp1 = p1, bp2 = p2;
      p1 -= i, p2 -= j;
    }
  p1 = bp1, p2 = bp2;
//  fprintf(stderr, "k[0]=%d k[1]=%d k[2]=%d\n", k[0], k[1], k[2]);
//  fprintf(stderr, "ans <- %lld len = %d p1=%d p2=%d p3=%d\n", sum(), len(), p1, p2, p3);
  ans = max(ans, sum());
}

int main()
{
  freopen("lecture.in", "r", stdin);
  freopen("lecture.out", "w", stdout);

  assert(scanf("%d%d", &n, &t) == 2);
  assert(1 <= n && n <= 100000);
  assert(1 <= t && t <= 300000);
  for (int i = 0; i < 3; i++)
    a[i][0] = 0, k[i] = 1;
  for (int i = 0; i < n; i++)
  {
    int q, p;
    assert(scanf("%d%d", &q, &p) == 2);
    assert(1 <= q && q <= 3);
    assert(0 <= p && p <= 1000000000);
    q--;
    a[q][k[q]++] = p;
  }
  for (int i = 0; i < 3; i++)
    sort(a[i] + 1, a[i] + k[i], greater<long long>());
  for (int i = 0; i < 3; i++)
    for (int j = 1; j < k[i]; j++)
      a[i][j] += a[i][j - 1];
  p1 = p2 = p3 = 0;
  int bp1 = 0, bp2 = 0, bsum = 0;
  for (p1 = 0, p2 = k[1] - 1; p1 < k[0]; p1++)
  {
    while (p2 > 0 && len() > t)
      p2--;
    if (len() <= t && bsum < sum())
//    {
//      fprintf(stderr, "bsum <- %lld len = %d p1=%d p2=%d\n", sum(), len(), p1, p2);
      bsum = sum(), bp1 = p1, bp2 = p2;
//      fprintf(stderr, "bp1=%d bp2=%d\n", bp1, bp2);
//    }
  }
  p1 = bp1, p2 = bp2;
//  fprintf(stderr, "ans <- %lld len = %d p1=%d p2=%d\n", sum(), len(), p1, p2);
  ans = sum();
//  for (p3 = 1; p3 < k[2] && p3 * 3 <= t; p3++)
//    update();
  for (p3 = 0; p3 < k[2]; p3++)
  {
    long long cu = 0;
    int x1 = -1, x2 = -1;
    for (p2 = 0; p2 < k[1]; p2++)
      for (p1 = 0; p1 < k[0]; p1++)
        if (len() == t && sum() > cu)
          cu = sum(), x1 = p1, x2 = p2;
    printf("p3=%d p2=%d p1=%d\n", p3, x2, x1);
    if (cu > ans)
      ans = cu;
  }

  cout << ans << endl;

  return 0;
}
