"""
usage:
working directory should contain: lecture_am.class and a.exe (two different solutions)
when answers differs script terminate (counter example in lecture.in)
WORKING_N - constant sets N in random tests
"""
import random, os
from amtest import *

problemname = 'lecture'
MAXN  = pow(10,5)
MAXT  = 3 * MAXN
MAXAI = pow(10,9)
WORKING_N = 30

import os
def rm(s):
  try:os.remove(s)
  except Exception:pass

def rt(n, mint=1):
  assert(1 <= mint <= 3)
  a = []
  t = 0
  for i in range(n):
    j = random.randint(mint,3)
    t += j
    a.append( (j, random.randint(0,MAXAI)) )
  t = random.randint(1,min(MAXT,t + (t/20)))
  pt( (t, a) )

def pt(z):
  T,a = z
  N = len(a)
  assert(1 <= N <= MAXN)
  assert(1 <= T <= MAXT)
  f = open(problemname + '.in','w')
  f.write('%d %d\n' % (N,T))
  for t,v in a:
    f.write("%d %d\n" % (t,v))
    assert(1 <= t <= 3)
    assert(0 <= v <= MAXAI)
  f.close()

def run(seed):
  random.seed(seed)
  t = rt(WORKING_N)
  rm(problemname + '.out')
  os.system('C:\PROGRA~1\JAVA\JDK15~1.0_0\BIN\java.exe -ea -Xmx256M -Xss64m ' + problemname + '_am')
  f = open(problemname + '.out','r')
  s1 = f.readline().rstrip()
  f.close()
  #os.system('C:\PROGRA~1\JAVA\JDK15~1.0_0\BIN\java.exe -ea -Xmx256M -Xss64m ' + problemname + '2_am')
  os.system('a.exe')
  f = open(problemname + '.out','r')
  s2 = f.readline().rstrip()
  f.close()
  print 'seed = %d s1 = %s s2 = %s' % (seed,s1,s2)
  if s1<>s2:
    print ('counter example seed = %d' % seed)
    return True
  return False

def fl(b1,best1,b2,best2,t1,t2):
  f = open('best','w')
  f.write('%d %d %s\n%d %d %s\n' % (b1,best1,t1,b2,best2,t2) )
  f.close()

def main():
  for k in xrange(717,10000):
    #if (k % 10) <> 0: print k
    if run(k): break
main()
