{$I trans.inc}
program macro;
uses testlib;
const MaxN = 4; eps = 1.1e-6;
var xj, yj, xc, yc: array [0..MaxN] of Extended;
 jury, cont, sj, sc: Extended;
 i: Integer;

function vp (x0, y0, x1, y1, x2, y2: Extended): Extended;
begin
  vp := ((x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0)) * 0.5;
end;

BEGIN
  for i := 1 to MaxN do begin
    jury := ans.readreal;
    cont := ouf.readreal;
    if abs (jury - cont) > eps then
      quit (_wa, 'Required: ' + r2s (jury) + ', got: ' + r2s (cont));
    xj[i] := jury;
    xc[i] := cont;
    jury := ans.readreal;
    cont := ouf.readreal;
    if abs (jury - cont) > eps then
      quit (_wa, 'Required: ' + r2s (jury) + ', got: ' + r2s (cont));
    yj[i] := jury;
    yc[i] := cont;
  end;
  if not ouf.seekeof then
    quit (_pe, 'EOF expected');
  xj[0] := xj[MaxN]; yj[0] := yj[MaxN];
  xc[0] := xc[MaxN]; yc[0] := yc[MaxN];
  sj := 0.0; sc := 0.0;
  for i := 1 to MaxN do begin
    sj := sj + vp (0.0, 0.0, xj[i], yj[i], xj[i - 1], yj[i - 1]);
    sc := sc + vp (0.0, 0.0, xc[i], yc[i], xc[i - 1], yc[i - 1]);
  end;
  if abs (sj - sc) > eps then
    quit (_wa, 'Area: required ' + r2s (sj) + ', got ' + r2s (sc));
  quit (_ok, 'Answer: ' + r2s (sc));
END.
