#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "squaring"

const int MaxC = 100, MinC = -MaxC, MinR = 1, MaxR = 100;

int x, y, r;

int main (void)
{
 double d;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d %d", &x, &y, &r) != EOF)
 {
  assert (MinC <= x && x <= MaxC);
  assert (MinC <= y && y <= MaxC);
  assert (MinR <= r && r <= MaxR);
  d = r * sqrt (M_PI);
  d *= 0.5;
  printf ("%.12lf %.12lf\n", x - d, y - d);
  printf ("%.12lf %.12lf\n", x - d, y + d);
  printf ("%.12lf %.12lf\n", x + d, y + d);
  printf ("%.12lf %.12lf\n", x + d, y - d);
 }
 return 0;
}
