#include <cstdio>
#include <cmath>
#include <cassert>

int main()
{
  freopen("squaring.in", "r", stdin);
  freopen("squaring.out", "w", stdout);

  int x, y, r;
  assert(scanf("%d%d%d", &x, &y, &r) == 3);
  assert(-100 <= x && x <= 100);
  assert(-100 <= y && y <= 100);
  assert(1 <= r && r <= 100);
  float s = M_PI * r * r;
  float a = 0.5 * sqrt(s);
  printf("%.7f %.7f\n", x - a, y - a);
  printf("%.7f %.7f\n", x - a, y + a);
  printf("%.7f %.7f\n", x + a, y + a);
  printf("%.7f %.7f\n", x + a, y - a);

  return 0;
}
