#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <algorithm>

using namespace std;

int rseed;
void osrand( int a ) { rseed = a; }
int orand() { return (rseed = (rseed * 239017 + 301703) & 0xffffff) >> 8; }
int r( int a, int b ) { return a + orand() % (b - a + 1); }

#define m 100100

int p[m], a[2 * m], st[m], en[m];

int main( int argc, char **argv )
{
  assert(argc == 5);
  int n = atoi(argv[1]);
  int k = atoi(argv[2]);
  int ma = atoi(argv[3]);
  osrand(atoi(argv[4]));

  for (int i = 0; i < 2 * n; i++)
    a[i] = r(0, ma);
  sort(a, a + 2 * n);
  for (int i = 0; i < n; i++)
    st[i] = a[2 * i + 0], en[i] = a[2 * i + 1];
  
  for (int i = 0; i < n; i++)
  {
    p[i] = p[r(0, i)];
    p[p[i]] = i;
  }
  printf("%d %d\n", n, k);
  for (int i = 0; i < n; i++)
    printf("%d %d\n", st[p[i]], en[p[i]]);
  return 0;
}
