import java.util.*;
import java.io.*;
public class timetable_am
  {
  static final String filename = "timetable";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_N = 100000;
  static final int MAX_K = 100;
  static final int MAX_C = (int) 1e9;
  static int N,K;
  static Seg[] a;
  static int[] next;
  static int e[][];
  static class Seg implements Comparable<Seg>
  {
  int u,v;
  Seg(int u,int v)
  {
  if (u > v) throw new Error("wrong segment" + "(" + u + "," + v + "); start>dest");
  if (u < 0 || u > MAX_C || v < 0 || v > MAX_C)
      throw new Error("wrong segment" + "(" + u + "," + v + ") - end out of range");
  this.u = u;
  this.v = v;
  }
  public int compareTo(Seg a)
  {
  if (this.u == a.u)
    {
    if (this.v > a.v) return -1;
    if (this.v < a.v) return  1;
    return 0;
    }
  if (this.u < a.u) return -1;
  return 1;
  }

  }
  /*
  static int f(int k,int i)
  {
  if (e[k][i] != Integer.MIN_VALUE) return e[k][i];
  int j = next[i];
  return e[k][i] = Math.max(Math.max(f(k, i+1), (a[j-1].u - a[i].u) + f(k-1, j-1) ),
                            (a[i].v - a[i].u) + f(k-1, j)  );
  }
  */
  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(2),i,j,k;
  N = z[0];K = z[1];
  if (N < 1 || N > MAX_N) throw new Error("N - out of range");
  if (K < 0 || K > MAX_K) throw new Error("K - out of range");
  a = new Seg[N];
  for(i=0;i<N;++i)
    {
    z = readIntegersSeparatedByOneSpace(2);
    a[i] = new Seg(z[0],z[1]);
    }
  Arrays.sort(a);
  //  
  int m = 0;for(i=1;i<N;++i) if (a[m].v < a[i].v) a[++m] = a[i];++m;
  Seg[] b = new Seg[m];
  System.arraycopy(a, 0, b, 0, m);
  a = b;N = m;

  next = new int[N];
  for(i=0,j=0;i<N;++i)
    {
    while(j<N && a[j].u <= a[i].v) ++j;
    next[i] = j;
    }

  e = new int[K+1][N+1];
  Arrays.fill(e[0],0);
  for(i=1;i<=K;++i)
    {
    Arrays.fill(e[i],Integer.MIN_VALUE);
    e[i][N] = 0;
    }

  for(i=N-1;i>=0;--i)
    {
    j = next[i];
    for(k=1;k<=K;++k)
      {
      e[k][i] = Math.max(Math.max(e[k][i+1], (a[j-1].u - a[i].u) + e[k-1][j-1]),
                        (a[i].v - a[i].u) + e[k-1][j]  );
      }
    }

  out.println(e[K][0]);
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
