import java.util.*;
import java.io.*;

public class worms_am_treemap
  {
  static final String filename = "worms";
  static BufferedReader in;
  static PrintStream out;
  static final int MAX_N = 10000;
  static final int MAX_M = 100000;
  static final int MAX_PAGES = 10000;
  static int N,M;
  static int[] p,a;
  static int getPageId(int book,int page)
  {
  if (page < 1 || page > p[book-1]) throw new Error("book = " + book + " page = " + page + "(page out of range)");
  return a[book-1] + (p[book-1] - page);
  }
  static void incr(TreeMap<Integer,Integer> m,int x,int delta)
  {
  Integer I = m.get(x);
  int k = 0;
  if (I != null) k = I;
  k += delta;
  m.put(x,k);
  }
  static void test() throws IOException
  {
  int z[] = readIntegersSeparatedByOneSpace(2),i,j,k;
  N = z[0];M = z[1];
  if (N < 1 || N > MAX_N) throw new Error("N is out of range");
  if (M < 1 || M > MAX_M) throw new Error("M is out of range");
  p = readIntegersSeparatedByOneSpace(N);
  a = new int[N+1];
  for(i=1;i<=N;++i) a[i] = a[i-1] + p[i-1];
  TreeMap<Integer,Integer> m = new TreeMap<Integer,Integer>();
  for(j=0;j<M;++j)
    {
    z = readIntegersSeparatedByOneSpace(4);
    int u = getPageId(z[0],z[1]),v = getPageId(z[2],z[3]);
    if (u>v) {int tmp = u;u = v;v = tmp;}
    incr(m, u, 1);
    incr(m, v+1, -1);
    }
  int c[] = new int[M+1];
  int x = 0,worms = 0;
  for(Integer I : m.keySet())
    {
    i = I;
    c[worms] += i - x;
    worms += m.get(I);
    x = i;
    }
  c[worms] += a[N] - x;
  for(i=0;i<=M;++i) out.println(c[i]);
  }
  public static void main (String[] argv) throws IOException
  {
  in = new BufferedReader(new InputStreamReader(new FileInputStream(filename+ ".in")));
  out = new PrintStream(new BufferedOutputStream(new FileOutputStream(filename + ".out")));
  test();
  if (in.readLine()!=null) throw new Error("eof expected");
  in.close();
  out.close();
  }
static int line;
static int[] readIntegersSeparatedByOneSpace(int alength) throws IOException
  {
  int r[] = new int[alength],k=0;
  for(String s : readTokensSeparatedByOneSpace(alength)) r[k++] = Integer.parseInt(s);
  return r;
  }
static String sline() {return "line #" + line + ": ";}
static List<String> readTokensSeparatedByOneSpace(int alength) throws IOException
  {
  int i;
  ++line;
  StringTokenizer st = new StringTokenizer(in.readLine()," ",true);
  Vector<String> v = new Vector<String>();
  for(i=0;;i++)
    {
    if (!st.hasMoreTokens()) break;
    String s = st.nextToken();
    if (0 == (i & 1)) v.add(s);
    else if (!s.equals(" "))
      throw new RuntimeException(sline() + "single space expected, but " + s + " found");
    }
  if (0 == (i & 1))
    throw new RuntimeException(sline() + "input line ended by whitespace");
  if (alength >= 0 && v.size() != alength)
    throw new RuntimeException(sline() +  "number of tokens != " + alength);
  return v;
  }
}
