/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

typedef long long ll;

int main() {
  ios_base::sync_with_stdio(0), cin.tie(0);

  int n;
  cin >> n;
  int x[n], y[n];
  forn(i, n) {
    cin >> x[i] >> y[i];
  }
  ll s = 0;
  forn(i, n) {
    int j = (i + 1) % n;
    s += x[i] * y[j] - x[j] * y[i];
  }
  if (s < 0) {
    reverse(x, x + n);
    reverse(y, y + n);
  }
  forn(i, n) {
    int j = (i + 1) % n;
    int k = (i + 2) % n;
    if ((x[k] - x[i]) * (y[j] - y[i]) - (x[j] - x[i]) * (y[k] - y[i]) > 0) {
      puts("NO");
      return 0;
    }
  }
  puts("YES");
  return 0;
}
