# -*- coding: utf-8 -*-

"""
@author: Kirill Python
@contact: https://vk.com/python273
"""

import sys
import vk_api

""" Пример получения последнего сообщения со стены """

login, password = sys.stdin.readline().split()
print(login, password)
vk = vk_api.VkApi(login, password)

try:
	vk.authorization()
except vk_api.AuthorizationError as error_msg:
	print(error_msg)
	exit()

print("Authorization : OK");
print(vk.token["access_token"])

"""
	VkApi.method позволяет выполнять запросы к API. В этом примере
	используется метод wall.get (https://vk.com/dev/wall.get) с параметром
	count = 1, т.е. мы получаем один последний пост со стены текущего
	пользователя.
"""
response = vk.method('wall.get', {'count': 1})  # Используем метод wall.get
if response['items']:
	print(response['items'][0]['text'])
