/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 * Two times faster under 64-bit compiler
 */

#include <ctime>
#include <cstdio>
#include <cassert>
#include <iostream>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

int main() {
  #define NAME "testtime"
  assert(freopen(NAME ".in", "r", stdin));
  assert(freopen(NAME ".out", "w", stdout));

  long long n, sum = 0, k;
  cin >> n;
  for (k = 1; k * k <= n; k++)
    sum += n / (k * k);
  cout << sum << endl;
  fprintf(stderr, "time = %.2f, bits = %d\n", 1. * clock() / CLOCKS_PER_SEC, sizeof(int *) * 8); // stamp
  return 0;
}
