#!/usr/bin/env python3

import sys
import burunduk3_bayes

m = {}
for x in sys.stdin.readlines ():
    for w in map (burunduk3_bayes.word_clear, x.split ()):
        if not len (w):
            continue
        if w not in m:
            m[w] = 0
        m[w] += 1

for w in sorted (m.keys ()):
    print ("%8d %s" % (m[w], w))

